#Copyright (c) 2008, MANDIANT Corporation
#All rights reserved.
#
#Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
#
#    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
#    * Neither the name of the MANDIANT Corporation nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
#INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
#DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
#SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
#SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
#WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
#USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'''
@author:       Peter Silberman
@license:      BSD  
@contact:      peter.silberman@mandiant.com
@organization: http://www.mandiant.com
'''

xml = """<?xml version="1.0" encoding="utf-8"?>
<script xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" chaining="implicit">
  <commands>
    <command xsi:type="ExecuteModuleCommand">
      <module name="w32processes-memory" version="1.0.34.0" />
      <config xsi:type="ParameterListModuleConfig">
        <parameters>
          <param name="pid">
            <value xsi:type="xsd:unsignedInt">4294967295</value>
          </param>

          <param name="handles">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="sections">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="ports">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="strings">
            <value xsi:type="xsd:boolean">true</value>
          </param>
          <param name="Filter Behavior">                                                                                               
            <value xsi:type="xsd:string">CompleteItem</value>                                                                         
          </param> 


        </parameters>
      </config>
      <filters>
        <filter>
          <module name="xpath" />
          <config xsi:type="ParameterListModuleConfig">
            <parameters>
              <param name="expression">
              <value xsi:type="xsd:string">%s</value>
              </param>
            </parameters>
          </config>
        </filter>
      </filters>
    </command>
    
  </commands>
</script>
"""

xml_memory = """<?xml version="1.0" encoding="utf-8"?>
<script xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" chaining="implicit">
  <commands>
    <command xsi:type="ExecuteModuleCommand">
      <module name="w32processes-memory" version="1.0.34.0" />
      <config xsi:type="ParameterListModuleConfig">
        <parameters>
          <param name="pid">
            <value xsi:type="xsd:unsignedInt">4294967295</value>
          </param>

          <param name="handles">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="sections">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="ports">
            <value xsi:type="xsd:boolean">false</value>
          </param>
          <param name="strings">
            <value xsi:type="xsd:boolean">true</value>
          </param>
          <param name="Filter Behavior">                                                                                               
            <value xsi:type="xsd:string">CompleteItem</value>                                                                         
          </param> 
          <param name="memory file">
            <value xsi:type="xsd:string">%s</value>
          </param>


        </parameters>
      </config>
      <filters>
        <filter>
          <module name="xpath" />
          <config xsi:type="ParameterListModuleConfig">
            <parameters>
              <param name="expression">
              <value xsi:type="xsd:string">%s</value>
              </param>
            </parameters>
          </config>
        </filter>
      </filters>
    </command>
    
  </commands>
</script>
"""

py = """class %s:
    def __init__(self, parent=None):
        self.parent = parent
        self.attributes 		= {}
        self.attributes["author"]	= "Peter Silberman"
        self.attributes["description"]  = "auto generated"
        self.attributes["date"]		= "11/17/08"
        self.attributes["url"]		= "http://www.mandiant.com"
        self.attributes["signaturename"]= "%s"
        self.parent.RegisterSignature(self)
        
    def Signature(self):
        SearchCriteria = {}
        
        SearchCriteria["CaseIns"] = True
        SearchCriteria["type"] = "strings"   
        SearchCriteria["text"] = %s
        SearchCriteria["regex"] = %s
        SearchCriteria["signature"] = 1
        SearchCriteria["name"] = self.attributes["signaturename"]
        return SearchCriteria 
    
    def ApplySignature(self):
        SearchCriteria = self.Signature()
        self.parent.SearchResults.SearchForSignature(SearchCriteria)
    """
def SantizePyString(str):
    try:
        return str.replace("\:", ":").replace("\\;", ";").replace("\\", "\\").replace('\"', '\\"').replace("\'", "\\'").encode('ascii', 'xmlcharrefreplace')
    except:
        print "Can not decode character BAILING..."
        return ""

def SanitizeName(name):
    return name.replace("[", "").replace("#","").replace("~", "").replace("@", "").replace(";","").replace("]", "").replace("&","").replace("!","").replace(",","").replace("+","").replace(":", "").replace("\'","").replace(".","").replace("(", "").replace("-","_").replace("%", "").replace(")","").replace(" ", "_").replace("/", "").replace("\\", "").replace(">", "").replace("<","").replace("=","").replace("*", "").replace("|","").replace("?", "").lower()

def WritePythonSignature(sig, output_path):
    text = regex = None
    q = ""
    name = SanitizeName(sig["SignatureName"])
    if sig["SignatureContents"] != None:
        text = []
        for s in sig["SignatureContents"]:
            text.append(SantizePyString(s))
    
    if sig["SignaturePCRE"] != None:
        regex = []
        for s in sig["SignaturePCRE"]:
            regex.append(SantizePyString(s) )
        
    if sig["SignaturePCRE"] != None or sig["SignatureContents"] != None:
        fd = open("%s%s" % (output_path, (name + ".py")), "w+") 
        fd.write(py % (name, name, text, regex) )
        fd.close()
        return 1
    return 0

def SantizeXString(str):
#&  &amp;
#<  &lt;
#>  &gt;
#"  &quot;
#'  &apos;

    str = str.replace("\:", ":").replace("\\;", ";").replace("\\", "\\")
    str = str.replace("&", "&amp;")
    s = str.replace("<", "&lt;").replace(">", "&gt;").replace("\'", "&apos;").replace("\"", "&quot;").replace("&", "&amp;")
    return s

    

def WriteXPathSignature(sig, output_path, nand, memory_file):
    #//*[(contains(lower-case(StringList), '?abc=')) and (contains(lower-case(StringList), '/test')) and (contains(lower-case(StringList), '.php'))]
    q = ""
    inclusion_verb = "and"
    
    if nand:
        inclusion_verb = "or"
    final = "//*[(%s)]"
    if sig["SignatureContents"] != None:
        i = 0
        while i < len(sig["SignatureContents"])-1:
            s = SantizeXString(sig["SignatureContents"][i]) 
            q += "contains(StringList, \'%s\') %s " % (s, inclusion_verb)
            i+=1
        s = SantizeXString(sig["SignatureContents"][len(sig["SignatureContents"])-1])
        q += "contains(StringList, \'%s\')" % s
        #
        # add an and if there is PCRE work to be done 
        #
        if sig["SignaturePCRE"] != None:
            q+= " %s " % inclusion_verb
    
    if sig["SignaturePCRE"] != None:
        i = 0
        while i < len(sig["SignaturePCRE"])-1:
            s = SantizeXString(sig["SignaturePCRE"][i])
            q += "matches(StringList, \'%s\') %s " % (s, inclusion_verb)
            i+=1
        s = SantizeXString(sig["SignaturePCRE"][len(sig["SignaturePCRE"])-1])
        q += "matches(StringList, \'%s\')" % s
      
    if sig["SignaturePCRE"] != None or sig["SignatureContents"] != None:
        final = final % q
        fd = open("%s%s" % (output_path, SanitizeName(sig["SignatureName"]) + ".Signature.xml"), "w+")
        if memory_file:
            fd.write(xml_memory % (memory_file, final) )
        else:
            fd.write(xml % final)
        fd.close()
        return 1
    return 0

    
            
            
